package com.eactive.eai.batch.job.jobItem.fiusc;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.util.ArrayList;

import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;

import com.eactive.eai.batch.osd.OutsideManager;
import com.eactive.eai.batch.osd.OutsideVO;
import com.eactive.eai.common.exception.ExceptionUtil;

public class RECV_FIUSC_0302 extends DefaultTelegram implements TelegramService
{
    private int INFORMALFIELD_INDEX = 22;		// 전자서명 HASH data 항목의 INDEX
    
    private ByteArrayOutputStream bout;
	
    /**
     * 생성자
     */
    public RECV_FIUSC_0302() {
        //파일 시작 요구
        bout = new ByteArrayOutputStream();
    }

    /**
     * 전문 해체하기
     */
    public boolean doExecute() {
        if (!super.doExecute()) return false;

        try{
            String sysCode     = new String ((byte[]) al_Field.get(2));
            String compGb      = new String ((byte[]) al_Field.get(20));
            String strFileSize = new String ((byte[]) al_Field.get(21));
            long fileSize      = Long.parseLong(strFileSize);

            String fileExt =  "";
            if ( compGb.equals("1")){
            	fileExt = ".Z";
            } else if (compGb.equals("2")){
            	fileExt = ".ZIP";
            }
            String fileName = new String ((byte[]) al_Field.get(15));
            if (fileExt.isEmpty()) {
            	fileName = fileName.trim();
            } else {
            	fileName = fileName.trim() + fileExt;  // 보고 파일명
            }
            
            //파일명으로 부터 거래 구분 코드 추출
			int bizCodeStartIndex = 0;
			int bizCodeEndIndex = 0;
			String processCode = batchDoc.getBatchMsg().getHeader().getProcessCode();
			String institutionCode = batchDoc.getBatchMsg().getHeader().getInstitutionCode();
			ArrayList<OutsideVO> organList = OutsideManager.getInstance().getOutsideInfo(processCode);
			for (int i = 0; organList != null && i < organList.size(); i++) {
				OutsideVO organInfo = organList.get(i);
				if (institutionCode.equals(organInfo.getOsdCode())) {
					bizCodeStartIndex = organInfo.getBizCdStartIdx();
					bizCodeEndIndex = organInfo.getBizCdEndIdx();
					break;
				}
			}
			if (bizCodeStartIndex <= 0 || bizCodeStartIndex >= fileName.length()) bizCodeStartIndex = 0;
			if (bizCodeEndIndex <= 0 || bizCodeEndIndex > fileName.length()) bizCodeEndIndex = fileName.length();
			String bizCode = fileName.substring(bizCodeStartIndex, bizCodeEndIndex);

            batchDoc.getBatchMsg().getHeader().setBizCode(bizCode);
            batchDoc.getBatchMsg().getHeader().setFileName(fileName);
            batchDoc.getBatchMsg().getHeader().setFileSize(fileSize);
        
            String fileDir = batchDoc.getBatchMsg().getHeader().getFilePath();
            if (fileDir.charAt(fileDir.length()-1) != File.separatorChar) {
                fileDir = fileDir + this.getSeparator();
            }
            String fileFullName = fileDir + fileName;
            File file = new File(fileFullName);
            if (file.exists()) file.delete();
            
            // 초기화
            batchDoc.getBatchMsg().getBody().setCurFileSize(0L);
            batchDoc.getBatchMsg().getBody().setBlockNum(0);
            batchDoc.getBatchMsg().getBody().setSeqNum(0);

        } catch ( Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI001";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error(e.getMessage(),e);
            return false;
        }
        return true;
    }

    /**
     * 전문 Validation
     */
    public boolean doValidation()
    {
        if (!super.doValidation()) return false;
        return true;
    }

    /**
     * int getCalculatedLength(int idx)
     * --------------------------------------------------------------------------------------
     * 전달된 인덱스 idx는 비정형 필드여야 한다. 즉 필드의 길이값이 FILE_NO_LENGTH("XX") 이어야 한다.
     * 해당 비정형 필드에 대해 실질적인 전문길이를 동적으로 계산해 낸다.
     * SEND : 송신 길이 계산
     * RECV : 수신 길이 계산
     */
    public int getCalculatedLength(int idx) {
        if (idx >= this.getFieldCount()) {
            logger.debug("{} getCalculatedLength> parameter is bigger than field count", logHeader);

            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = ""+idx;
            String errCode = "BECEAIFJI011";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);

            return -1;
        }
        if (this.getFieldLength(idx).equalsIgnoreCase(TelegramService.FIELD_NO_LENGTH)) {
        	
            String hashLength  = new String ((byte[]) al_Field.get(19));  // 레코드길이(4) 기본값 "0001"
            
            // Byte거래 이므로 레코드길이(4) 기본값이 "0001"인데, 송신 테스트를 위해 전자서명 데이터 byte 길이 입력 
            String byte_size = hashLength.equals("0001") ? "0" : hashLength; //전자서명 PEM DATA Byte수 
            logger.info("{} the sum of definite field length [" + byte_size + "]", logHeader);

            try {
                return Integer.parseInt(byte_size);
            } catch(Exception e) {
                String[] msgArgs = new String[1];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                String errCode = "BECEAIFJI005";
                String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                logger.error(e.getMessage(),e);
                return -1;
            }

        } else {

            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = ""+idx;
            String errCode = "BECEAIFJI012";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);

            return -1;
        }
    }

    public boolean doInformalField(int idx, byte[] data, int length)
    {
        try {
            if (idx == INFORMALFIELD_INDEX) {
                bout.write(data, 0, length);
                // 전자서명 비정형데이터 수신확인
                logger.debug("{} doInformalField >> received e-Sign Hash Data : "+new String(bout.toByteArray()), logHeader);
            } else {
                logger.debug("{} doInformalField >> index of informal action error : " + idx, logHeader);

                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI012";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);

                return false;
            }
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI004";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error(ex.getMessage(),ex);
            return false;
        }
        return true;
    }
    
    public boolean doPostExecute() {
        if (!super.doPostExecute()) return false;
        try {
        	
			//DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<10; i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=10; i< al_Field.size()-1; i++) {  // 전자서명 필드는 비정형 필드로 바디 로그에서 제외
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));

            return true;

        } catch(Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error(ex.getMessage(),ex);
            return false;
        }
    }

    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
    	String telegramNo = super.getFieldValueString(5);
    	if ( telegramNo.length() < 8 ) return "";
		return telegramNo.substring(0,3) + telegramNo.substring(6,7);
    }

    //응답코드 필드값 리턴
    public String getResCode()
    {
		return super.getFieldValueString(9);
    }
}
